#!/bin/sh
B="[bcmk]"
BCMK_LAST=0
BCMK_TOT=0
BCMK_PRT=0
_bcmk_time_get() {
	local retv="${1}"
	local bcmk_time
	local bcmk_offs
	if [ ${BE_TGT} -eq 1 ]; then
		bcmk_offs=10
		bcmk_time=$(cat /proc/timer_list | grep "now at" | \
			grep -Eo "[0-9]*") || ret=$?
	else
		bcmk_offs=0
		bcmk_time=$(date +%s%N) || ret=$?
	fi
	if [ ${ret} -ne 0 ]; then
		printf "%s Error '%d' getting nanoseconds!\n" "${B}" "${ret}"
		return ${ret}
	elif [ -z "${bcmk_time}" ]; then
		printf "%s Could not get nanoseconds!\n" "${B}"
		return 1
	fi
	eval "${retv}=\${bcmk_time}:\${bcmk_offs}"
	return 0
}
bcmk_mark() {
	[ ${BE_BCMK} -eq 0 ] && return 0
	local ret=0
	local blob=""
	local time=""
	local offs=""
	_bcmk_time_get blob || ret=$?
	if [ ${ret} -ne 0 ]; then
		printf "%s Error '%d' getting time blob!\n" "${B}" "${ret}"
		return ${ret}
	fi
	IFS=':' read -r time offs <<< "${blob}" || ret=$?
	if [ ${ret} -ne 0 ]; then
		printf "%s Error '%d' reading time blob!\n" "${B}" "${ret}"
		return ${ret}
	fi
	BCMK_LAST="${time}"
	BCMK_PRT=0
	return 0
}
bcmk_diff() {
	[ ${BE_BCMK} -eq 0 ] && return 0
	local str="${1}"
	local ret=0
	local blob=""
	local time=""
	local offs=""
	_bcmk_time_get blob || ret=$?
	if [ ${ret} -ne 0 ]; then
		printf "%s Error '%d' getting time blob!\n" "${B}" "${ret}"
		return ${ret}
	fi
	IFS=':' read -r time offs <<< "${blob}" || ret=$?
	if [ ${ret} -ne 0 ]; then
		printf "%s Error '%d' reading time blob!\n" "${B}" "${ret}"
		return ${ret}
	fi
	BCMK_PRT=$(((${time} - ${BCMK_LAST}) / 1000000 - ${offs}))
	BCMK_LAST="${time}"
	BCMK_TOT=$((${BCMK_TOT} + ${BCMK_PRT}))
	printf "%s %-30s PARTIAL: %4d  TOTAL: %5d\n" "${B}" "${str}" \
		"${BCMK_PRT}" "${BCMK_TOT}"
	return 0
}
bcmk_init() {
	[ ${BE_BCMK} -eq 0 ] && return 0
	bcmk_mark || return 1
	printf "%s Mark has been set at '%d'\n" "${B}" "${BCMK_LAST}"
	return 0
}
bcmk_init
INC_BCMK=1
