#!/bin/sh
readonly JLOG_NMSP="jlog_nmsp"
JLOG_COUNT=1
jlog_init() {
	[ ${BE_JLOG} -eq 0 ] && return 0
	local name="${1}"
	local prev_nmsp
	json_set_namespace "${JLOG_NMSP}" prev_nmsp
	json_init
	json_set_namespace ${prev_nmsp}
	jlog_err "${name}" "Initialized Log Manager"
	return 0
}
jlog_dump() {
	[ ${BE_JLOG} -eq 0 ] && return 0
	local prev_nmsp
	local json
	json_set_namespace "${JLOG_NMSP}" prev_nmsp
	json=$(json_dump)
	json_set_namespace ${prev_nmsp}
	echo "${json}"
	return 0
}
jlog_err() {
	[ ${BE_JLOG} -eq 0 ] && return 0
	local func="$1" && shift
	local str="$@"
	local prev_nmsp
	local prev_ifs
	json_set_namespace "${JLOG_NMSP}" prev_nmsp
	prev_ifs=$IFS
	IFS="
	"
	for line in ${str}; do
		json_add_string "${JLOG_COUNT}|${func}" "${line}"
		slog_err "${func}" "${line}"
		JLOG_COUNT=$((${JLOG_COUNT}+1))
	done
	IFS=${prev_ifs}
	json_set_namespace ${prev_nmsp}
	return 0
}
INC_JLOG=1
