#!/bin/sh
[ -z "${INC_UCI_CMT}" ] && . ${SH}/be_uci_commit.sh
[ -z "${INC_UCI_GET}" ] && . ${SH}/be_uci_get.sh
[ -z "${INC_UCI_SET}" ] && . ${SH}/be_uci_set.sh
do_uci() {
	local proc="${1}"
	local retv="${2}"
	local f="${FUNCNAME[0]}"
	local ret=0
	local sign=""
	local ures=""
	utils_check_retv "${retv}" "proc" "sign" "ures" || return $?
	if [ -z "${proc}" ] || [ -z "${retv}" ]; then
		jlog_err ${f} "Missing mandatory arguments!"
		return 1
	fi
	case "${proc}" in
	"commit")
		ubus_sign_get "${post_body}" sign || ret=$?
		if [ ${ret} -ne 0 ]; then
			jlog_err ${f} "Could not get signature of POST request!"
			return ${ret}
		fi
		uci_commit "${sign}" ures || ret=$?
		;;
	"get")
		uci_get ures || ret=$?
		;;
	"set")
		ubus_sign_get "${post_body}" sign || ret=$?
		if [ ${ret} -ne 0 ]; then
			jlog_err ${f} "Could not get signature of POST request!"
			return ${ret}
		fi
		uci_set "${sign}" ures || ret=$?
		;;
	*)
		jlog_err ${f} "Procedure '${proc}' is invalid!"
		ret=1
		;;
	esac
	if [ ${ret} -ne 0 ]; then
		jlog_err ${f} "Error occurred in '${proc}' procedure!"
		return ${ret}
	fi
	eval "${retv}=\${ures}"
	return 0
}
INC_UCI=1
